# Surgeweb addressbook handling
# -----------------------------
# This file should pull out all the generic addressbook management, autocompletion and address picker functionality
# out of the normal surgeweb code into a reusable module ...
# -----------------------------
# Logical groupings:
# rcpt_picker: Address search and pick dialog. prereq: has address_book info
# rcpt_lister: Fancy address listing field
# -----------------------------

# *** Actual addressbook / contactlist implementation ***
# --- implementation: Addressbook searching, indexing, on demand search implementation ---
// Move from x_abk_*.js files
var address_book;
address_book.data=[];
address_book.groups=[];
address_book.ac_order=[];

var abooks={};

function books_list(rb,wb)
{
	// Old storage
	sw.abooks_old=rb;
	sw.abooks_write=wb;

return;
	// New storage
	abooks.read_books=rb;
	abooks.write_books=wb;
	for(var i=0;i<rb.length;i++){
		var bk=abooks[rb[i]]={};
		bk.data=[];
		bk.groups=[];
#		bk.ac_order=[];
	}
}


# Append or update addressbook entry
function abook_entry(cid,a,late_add)
{
	// old storage
	if(cid.length==0){
		address_book.data.push(a);
		if(late_add){
			add_to_picker(address_book.data.length-1);
			address_book.ac_order.push(address_book.data.length-1);
		}
	}else{
		address_book.data[cid]=a;
	}
return;
	
	// new storage
	if(cid.length==0){
		if(!a.abook || !abooks[a.abook] ||!abooks[a.abook].data){
			// CQQQ catches webmail read only currently
			return
		}
		abooks[a.abook].data.push(a);
		if(late_add){
//			add_to_picker(address_book.data.length-1);
//			address_book.ac_order.push(address_book.data.length-1);
		}
	}else{
		abooks[a.abook].data[cid]=a;
	}	
}
function abook_entry_group(g,contact_ids)
{
	// old storage
    g.is_group=true;
    g.contacts = contact_ids.split(',');
    if (g.contacts.length==1 && g.contacts[0]=='') 
    	g.contacts=[];
	address_book.groups.push(g);
	
	// new storage
	// no facility for groups yet...
}
function abook_ac_order(arr)
{
	// old storage
	address_book.ac_order=arr;
return;
	
	// new storage
	abooks['User'].ac_order=arr;	
}

# access to contact descriptive strings
function c_name_string(c,noco)
{
	var co=(c.company?val(c.company.value):'');
	var first=(c.name?val(c.name.first):'');
	var last=(c.name?val(c.name.last):'');
	var email=(c.email?c.email[0].value:'');
	var srch=first+last+email+co;
	var txt='',hint='';
	
	if(c.file_by_co && co.length>0){
		if(noco){
			txt=first+' '+last; hint=co;
		}else{
			txt='<b>'+co+'</b>'; hint=first+' '+last;
		}
	}else if (last.length>0){
		txt=first+' <b>'+last+'</b>';
		hint=co;
	}else if (first.length>0){
		txt='<b>'+ first+'</b>';
		hint=co;
	}else if (c.email && email){
		txt='<b>'+email+'</b>';
		hint=co;
	}else {
		txt='Invalid contact name';
	}
	return '<span src="'+srch+'" title="'+hint+'">'+txt+'</span>';
}
function c_name(c)
{
	var first=(c.name?val(c.name.first):'');
	var last=(c.name?val(c.name.last):'');
	if (last.length>0)
		return first+' '+last;
	return first;
}
function c_name_co(c)
{
	var name = c_name(c);
	var co=(c.company?val(c.company.value):'');
	return (c.file_by_co || name=='') ? co : name;	
}
function c_email(c)
{
	if (c.email && c.email[0].value)
		return c.email[0].value;
	return '';
}
function contact_string_full(c)
{
	var first=(c.name?val(c.name.first):'');
	var last=(c.name?val(c.name.last):'');
	var email=(c.email?val(c.email[0].value):'');
	if(first.length==0 && last.length==0)	
		return email;
	if(email.length==0)
		return first+' '+last;
	return first+''+last+' &lt;'+email+'&gt;';
}
function contact_string_short(c)
{
	var first=(c.name?val(c.name.first):'');
	var last=(c.name?val(c.name.last):'');
	var email=(c.email?val(c.email[0].value):'');
	if(first.length>0 || last.length>0)	
		return first+' '+last;
	if(email.length>0)	
		return email;			
	return 'invalid contact name';
}




function c_name_new(txt)
{
	return {'first':txt,'last':''}
}
function c_email_new(txt)
{
	return [{'type':'work','value':txt}]
}


# *** implementation: cp_* (Contact Picker) ***
function cp_format_address(c,i,type)
{
	return  '<div class="xrow_container"><div class="xrow" onclick="cp_select(this,event)" abk_id="'+i+'">'\
			  +'<div class="xright">'
			  	+(c.shared?'<div class="cm_extra" title="Surgeweb shared addressbook entry (read only)">S</div>':'')
			  	+(c.webmail?'<div class="cm_extra" title="Old webmail addressbook entry (read only)">W</div>':'')+'</div>'
			  +'<div class="xcol1">&nbsp;</div>'
			  +'<div class="xcol2"><input id="'+type+i+'" type="checkbox"></div>'
			  +'<div class="xcol3">'+c_name_string(c,true)+'</div>'
			  +'<div class="xcol4">'+c_email(c)+'</div>'
		  	  +'</div></div>';
}
function cp_format_group(g)
{
	return '<div class="xrow_subcontainer closed" onclick="cp_select(this,event)" grp_name="'+g.name+'">'+
		   '<div class="xrow">'+
			'<div class="xright">'
			  	+(g.shared?'<div class="cm_extra" title="Surgeweb shared addressbook entry (read only)">S</div>':'')
			  	+(g.webmail?'<div class="cm_extra" title="Old webmail addressbook entry (read only)">W</div>':'')+'</div>'+
			'<div class="xcol1"><img src="||www_base||shared/img/1pixel.gif" class="xtog" onclick="xrow_toggle(this,event)"></div>'+
			'<div class="xcol2"><input type="checkbox"></div>'+
			'<div class="xcol3"><b style="font-size:1.1em">'+g.name+'</b></div>'+
			'<div class="xcol4">'+g.contacts.length+' Contacts</div>'+
		   '</div>';
}
function cp_format_group_address(c,i,type)
{
	return 	'<div class="xrow_container hidden" >'+
			   '<div class="xrow" abk_id="'+i+'">'+
				 '<div class="xright"></div>'+
				 '<div class="xcol1">&nbsp;</div>'+
				 '<div class="xcol2">&nbsp;</div>'+
				 '<div class="xcol3">'+c_name_string(c)+'</div>'+
				 '<div class="xcol4">'+c_email(c)+'</div>'+
			   '</div>'+
			 '</div>';
}
function cp_format_abook(name)
{
	return '<div class="xrow_container shared_abook">'+name+'</div>'
}
function cp_format_abook2(name)
{
	return '<div class="xrow_container" style="color:green; border-top:1px solid black;">'+name+'</div>'
}
function cp_format_abook3(name)
{
	return '<div class="xrow_container shared_abook3">'+name+'</div>'
}


# Fill add real data 
function cp_init(ctl_id)
{
	var i,j;
	var arr=[],fav=[];
	for (i=0;i<address_book.data.length;i++){
		var c=address_book.data[i];
		if(c.isfav) fav.push(cp_format_address(c,i,'cpf'));										
		if(c.isgroup) continue;
		arr.push(cp_format_address(c,i,'cpc'));
	}
	dge('ct_contacts_body').innerHTML=arr.join('');
	var txt=fav.join('');
	if (txt.length>0) dge('ct_favs_body').innerHTML=txt;	
	
	var arr=[];
	for (i=0;i<address_book.groups.length;i++){
		var g=address_book.groups[i];

		if(g.name=='Internal Directory'){
#			arr.push(cp_format_abook(g.name))
#			continue;
			arr.push('<div class="xrow_container shared_abook">Groups defined in directories</div>');	// MW:ABOOK
		}

		if(g.isfav) {continue;}
		if(g.contacts.length==0) {continue;}
		arr.push(cp_format_group(g));

		for (j=0;j<g.contacts.length;j++){
			var c=address_book.data[g.contacts[j]];
			if (!c) continue;
			arr.push(cp_format_group_address(c,g.contacts[j]));										
		}
		arr.push('</div>');
	}			
	dge('ct_groups_body').innerHTML=arr.join('');
	
}

function add_to_picker(i)
{
	var c=address_book.data[i];

	var a=new_anchor('div',cp_format_address(c,i,'cpf'));
	dge('ct_favs_body').appendChild(a.firstChild);
	a.parentNode.removeChild(a);

	var a=new_anchor('div',cp_format_address(c,i,'cpc'));
	dge('ct_contacts_body').appendChild(a.firstChild);
	a.parentNode.removeChild(a);
}


function cp_show(ctl_id)
{
	var cp=dge('contacts_picker');
	var ctl=dge(ctl_id);

	if(sw.is_popup && !cp){
		cp=new_anchor('div',sw_win.dge('contacts_picker_anchor').innerHTML);
		cp=cp.firstChild;
	}
	if(!cp){	// or no data??
		set_status("Address information is still being downloaded","warning");
		return;
	}
#	Unselect and reselect when switching fields
	if (cp.current_ctl!=ctl){
		if (cp.current_ctl){
			for(var li=cp.current_ctl.edit_li;li;li=li.previousSibling){
				if(li.mgr) cp_select_cb(li.mgr.cp_node,false);
			}				
		}		
		for(var li=ctl.edit_li;li;li=li.previousSibling){
			if(li.mgr) cp_select_cb(li.mgr.cp_node,true);
		}				
	}
	if (!cp.active_tab)
		cp_seltab('ct_favs');
	
	class_remove(cp,'hidden');	
#	pos_dropdown_by_ctl(cp,ctl)	
	menu_position(ctl,cp);
	cp.current_ctl=ctl;
}

function cp_select(el,e)
{
	cmgr_cp_select(e,el,el.selected!=true);
}
// Contact picker selection function designed to be called by cmgr to keep cp & cl in sync
function cp_select_cb(el,sel)
{
	if(sel){
		class_add(el,'selected');
		el.selected=true;
		xrow2sel(el).checked=true;
	}else{
		class_remove(el,'selected');
		el.selected=false;
		xrow2sel(el).checked=false;
	}
}




function xrow2sel(el)
{
	if(!el) return null;
	if (class_contains(el,'xrow_subcontainer'))
		return el.firstChild.firstChild.nextSibling.nextSibling.firstChild;
	else
		return el.firstChild.nextSibling.nextSibling.firstChild;
}

function cp_seltab(new_tab)
{
	var el=dge('contacts_picker');
	if (el.active_tab && el.active_tab.length>0){
		class_remove(dge(el.active_tab),'selected');
		class_add(dge(el.active_tab+'_body'),'hidden');
		var s=dge('cp_search');
		if (s.value!='' && s.value.indexOf('Search')==-1){
			s.value='';
			contact_search_do(s);
			s.value='Search for contact';
		}
	}

	class_add(dge(new_tab),'selected');
	class_remove(dge(new_tab+'_body'),'hidden');
	el.active_tab=new_tab;
	
	el=dge('cp_directories');
	if(new_tab=='ct_dir')
		class_remove(el,'hidden');
	else
		class_add(el,'hidden');
}

function cp_close(e)
{
#	dge('dlg_ovrl').style.display = 'none';
	var el=dge('contacts_picker');
	class_add(el,'hidden');
	stopEvent(e)
}



# *** implementation: cl_* (Contact Lister) ***
function cl_add_contact(c,location)
{
	if(!c){c=new Object;}
	// Do we get a picker row in or do we get a contact in??? I guess it has to be a contact entry of some kind...
#	var group=(class_contains(el,'xrow_subcontainer'))?true:false;

#	var ed=dge('edit_to_fancy');
#	if (!location) location=ed.firstChild.nextSibling.lastChild;
	if (!location) alert("foobar");
	var node=new_anchor4('li','txt',location);
	node.className='rcpt_valid';

	if (c.group){
		node.innerHTML='<img src="||www_base||shared/img/1pixel.gif" class="rcpt_expand" onclick="cl_expand(this,event)" title="expand group"><span>'+
					   '<b>'+c_name(c)+'</b></span>'+
					   '<img src="||www_base||shared/img/1pixel.gif" class="rcpt_remove" onclick="cl_remove(this,event)" title="remove address">';
		node.email=c_name(c);
	}else{
		var name=c_name(c);
		var email=c_email(c);
		var email2=(name.length>0 && email.length>0)?'&lt;'+email+'&gt;':email;
		node.innerHTML='<span onmouseup="cl_click(this,event)"><span>'+name+'</span>&nbsp;<span>'+email2+'</span></span><img src="||www_base||shared/img/1pixel.gif" class="rcpt_remove" onclick="cl_remove(this,event)" title="remove address">';
		node.email=name+'<'+email+'>';
		node.name_only=name;
		node.email_only=email;
	}
	return node;
}

function cl_remove(el,e)
{
	var el=target(e);
	while(el.tagName.toLowerCase()!='li') el=el.parentNode;	
	cl_remove_el(el,e);
}
#	If no manager do the removal ourselves else delegate to manager
function cl_remove_el(el,e)
{
	if (!el.mgr)
		cl_remove_cb(el);
	else
		cmgr_cl_remove(e,el);
}
function cl_remove_cb(el)
{
	var o=el.parentNode;
	o.removeChild(el);
	cl_setfocus(o);
}

var cx_contact;
function cl_click(el,e)
{
	var el=target(e);
	while(el.tagName.toLowerCase()!='li') el=el.parentNode;	
	cx_contact=el;
	do_menu_show('context_menu_contact',e,undefined,undefined,{cursor:true})
	stopEvent(e);
}
function cx_menu_contact(type)
{
	switch (type){
		case 'remove': 
			cl_remove_el(cx_contact); 
			break;
		case 'send': 
			contact_click_send(cx_contact.email_only,cx_contact.name_only); 
			break;
		case 'add': 
			contact_click_add(cx_contact.email_only,cx_contact.name_only); 
			if(class_contains(cx_contact,'rcpt_invalid')){
				class_remove(cx_contact,'rcpt_invalid');
				class_add(cx_contact,'rcpt_valid');
			}
			break;
	}
}

function cl_expand(el,e)
{
	var el=target(e);
	while(el.tagName.toLowerCase()!='li') el=el.parentNode;	
	cmgr_cl_expand(e,el);
}

function cmgr_cl_expand(e,clx)
{
	var cpx=clx.mgr.cp_node;		

#	cp_select(dge('cpc'+id))
	for (cpp=cpx.firstChild.nextSibling;cpp;cpp=cpp.nextSibling){
		var id=cpp.firstChild.getAttribute('abk_id');
		c=address_book.data[id];
		var cp=dge('cpc'+id).parentNode.parentNode;
		if (cp.selected) continue;
		cl=cl_add_contact(c,clx);
		cp_select_cb(cp,true);
		var m=new Object;
		m.cp_node=cp;
		m.cl_node=cl;		
		cp.mgr = cl.mgr = m;		
	}
	cpx.mgr=null;
	clx.mgr=null;
	cl_remove_cb(clx);
	cp_select_cb(cpx,false);	
}

function cl_onkeydown(ctl,e)
{	
	var el=target(e);
	while(el.tagName.toLowerCase()!='li') el=el.parentNode;	

	switch(e.keyCode){
		case 8:
			if(ctl.value=='' && el.previousSibling)
				cl_remove_el(el.previousSibling,e);
			break

		case 188: // COMMA
		case 186: // SEMICOLON
			if (e.shiftKey) break;			
			// drop through to tab
#		Enter
		case 13:
#		Tab
		case 9:
			if (ctl.value!=''){				
				var node=cl_add_contact(text2contact(ctl.value),el);
				node.className='rcpt_invalid'
				ctl.value='';
				stopEvent(e);
			}
			break;
		default:
	}
	resize_me(ctl,e);
}
function cl_onkeyup(ctl,e)
{	
	switch(e.keyCode){
		default:
	}
}
function cl_onpaste(ctl,e)
{	
#	alert("paste");
	setTimeout(function(){resize_me(ctl)},1);
}


# *** implementation: cmgr_* (Contact Manager) - syncronises contact picker and contact lister updates ***

# Add a selected contact
function cmgr_cp_select(e,cp,sel)
{
	if(sel){
		var m=new Object;

		var id=cp.getAttribute('abk_id');
		if(id){
			c=address_book.data[id];
		}else{
			c=text2contact(cp.getAttribute('grp_name'),true);
		}
		var o=cp;
		while(o.id!='contacts_picker') o=o.parentNode;
		var cl=cl_add_contact(c,o.current_ctl.edit_li);
		m.cp_node=cp;
		m.cl_node=cl;		
		cp.mgr = cl.mgr = m;		
	}else{
		var cl=cp.mgr.cl_node;		
		cp.mgr=null;
		cl.mgr=null;
		cl_remove_cb(cl);
	}
# 	Toggle selection on the picker
	cp_select_cb(cp,sel);	
}

# Remove a selected address
function cmgr_cl_remove(e,cl)
{
	var cp=cl.mgr.cp_node;		
	cp.mgr=null;
	cl.mgr=null;
	cl_remove_cb(cl);
	cp_select_cb(cp,false);	
}


function cl_outer_onclick(ctl,e)
{	
	cl_setfocus(ctl);
}

function cl_setfocus(el)
{	
	while(!el.edit_li) el=el.parentNode;
	el.edit_li.firstChild.focus();
}

function text2contact(txt,group)
{
	var c=new Object;

	if(group){
		c.group=true;
		c.name=c_name_new(txt);
	}else{
#		parse address etc
		if (txt.indexOf('<')!=-1){
			var x=txt.split('<');
			c.name = c_name_new(x[0]);
			var y=x[1].split('>');
			c.email = c_email_new(y[0]);
		}else{
			c.name=c_name_new(txt);
			c.mail=c_email_new(txt);
		}
	}
	return c;
}

function measure_text(o,txt)
{
	if (txt == " " || txt == "") return 50;
	o.innerHTML=txt;
	return o.offsetWidth+25;
}

function resize_me(ctl,event){
	var x=measure_text(ctl.ruler,encode_lt_gt(ctl.value));
	ctl.style.width=px(x);
}






# *** implementation: Autocompletion dialog implementation ***
// Still part of x_abk_*.js files

# *** implementation: Stuff for moving out of generic module... ***




#*** OLD STUFF  **

#	init_autocomplete();
function x_ac_pageload(){
	var x;
	if(true){
		x=sw.active.field_to; 
		if (x) ac_register_ctl(x, "default source");	
		x=sw.active.field_cc; 
		if (x) ac_register_ctl(x, "default source");	
		x=sw.active.field_bcc; 
		if (x) ac_register_ctl(x, "default source");	
		autocomplete.selected=0;
	}
	if(sw.is_popup) address_book=sw_win.address_book;
	
}



function contact_search_clear(ctl,e)
{
	if(ctl.value.indexOf("Search") != -1){
		ctl.value="";
	}
}

function contact_search_do(ctl,e)
{
	setTimeout(function(){contact_search_real(ctl)},10);
}	
function contact_search_real(ctl)
{
	var match=ctl.value.toLowerCase();
	var cp=dge("contacts_picker");

	if(cp.active_tab=='ct_dir'){
		return dir_search(match)
	}
	
	var tab=dge(cp.active_tab+'_body')
	class_add(tab,'hidden');
	for(row=tab.firstChild;row;row=row.nextSibling){
		x=row.innerHTML.toLowerCase();
        if(x.indexOf(match) != -1){
            class_remove(row,"hidden");
        }else{
	        class_add(row,"hidden");
        }
    }
   	class_remove(tab,'hidden');
}



# ***************************************
# ** Contacts management page ***
# ***************************************

function contacts_init()
{
	var i, gs=address_book.groups, g, extra;
	var arr=[];
||iftrue(marijn_dev)||
	arr.push(cp_format_abook3('Personal Contacts'))
||endif||	
#	arr.push('<div id="cm_all" class="cm_group" cm_gid="all">All Contacts</div>');
	for(i=0;i<gs.length;i++){
		g=gs[i];
		extra=''; 
		if(g.webmail) extra='<div class="cm_extra" title="Old webmail addressbook (read only)">W</div>';
		if(g.shared) extra='<div class="cm_extra" title="Surgeweb shared addressbook (read only)">S</div>';
		if(!g.nodelete) extra='<img src="||www_base||shared/img/1pixel.gif" class="delete_contact" title="Delete group" onclick="contact_delete_group('+i+',this,\''+g.name+'\',event)">';			

||iftrue(marijn_dev)||
		var padding=(g.name=='Favorites' || g.name=='All Contacts')?'':'padding-left:20px;'
||else||
		var padding='';
||endif||
		if(g.name=='Internal Directory'){
			padding='';
			arr.push(cp_format_abook3('Shared Contacts'))
			arr.push('<div class="cm_group" cm_gid="'+i+'" style="color:green;'+padding+'"><span class="cm_right">'+extra+'</span>'+'All Contacts'+' <span class="cm_count">'+(g.contacts.length>0?'('+g.contacts.length+')':'')+'</span></div>');
			padding='padding-left:20px;'
			arr.push('<div class="cm_group" cm_gid="'+i+'" style="color:green;'+padding+'"><span class="cm_right">'+extra+'</span>'+g.name+' <span class="cm_count">'+(g.contacts.length>0?'('+g.contacts.length+')':'')+'</span></div>');
			arr.push('<div class="cm_group" cm_gid="'+i+'" style="color:green;'+padding+'"><span class="cm_right">'+extra+'</span>'+'Development'+' <span class="cm_count">'+(g.contacts.length>0?'('+g.contacts.length+')':'')+'</span></div>');
			arr.push('<div class="cm_group" cm_gid="'+i+'" style="color:green;'+padding+'"><span class="cm_right">'+extra+'</span>'+'Massey (PNth)'+' <span class="cm_count">'+(g.contacts.length>0?'('+g.contacts.length+')':'')+'</span></div>');
			arr.push('<div class="cm_group" cm_gid="'+i+'" style="color:green;'+padding+'"><span class="cm_right">'+extra+'</span>'+'Massey (Albany)'+' <span class="cm_count">'+(g.contacts.length>0?'('+g.contacts.length+')':'')+'</span></div>');
			continue;
		}

		if(g.name=='All Contacts')
			arr.push('<div class="cm_group" cm_gid="all" style="'+padding+'">All Contacts <span class="cm_count">'+(address_book.data.length>0?'('+address_book.data.length+')':'')+'</span></div>');
		else
			arr.push('<div class="cm_group" cm_gid="'+i+'" style="'+padding+'"><span class="cm_right">'+extra+'</span>'+g.name+' <span class="cm_count">'+(g.contacts.length>0?'('+g.contacts.length+')':'')+'</span></div>');
	}
	dge('cm_groups').innerHTML=arr.join('');
#	dge('lpanel_contacts').innerHTML=arr.join('');

	dge('cm_details').innerHTML="details for selected contact";

#	sw.active.resize=contacts_resize;

	cm_reselect_group();
	dnd2_init();
}

function cm_reselect_group()
{
	var groups=dge("cm_groups");
	for(el=groups.firstChild;el;el=el.nextSibling){
		if(el.getAttribute('cm_gid')==cm_cur_group)
			break;
	}
#	if(!el && groups.firstChild) el=groups.firstChild.nextSibling;
#	Temporary change:	CQQQ
||iftrue(marijn_dev)||
	if((!el || el.innerHTML=='Personal Contacts') && groups.firstChild) el=groups.firstChild.nextSibling.nextSibling;
||else||
	if(!el && groups.firstChild) el=groups.firstChild.nextSibling;
||endif||
	dispatch_click(el);
}

function contacts_resize(h,w)
{
	if (sw.active.id!='contacts_panel') return;
	dbg("resizing contacts id="+sw.active.id+"h="+h+' w='+w);

#	var o=dge('cm_groups').parentNode;
#	if (isIE) {
#		if(o.scrollHeight>o.offsetHeight){
#			class_add(o,"hack_scroller");
#		}else{
#			class_remove(o,"hack_scroller");	
#		}
#	}
#	class_add(o,"hack_scroller");

	var o=dge('cm_contacts').parentNode;
	var s=o.style;
	s.height=px(h);
#	s.width=px(w*0.3);
	s.width=px(pref.sizer1*1.2);
	s=dge('cm_details').style;
#	s.marginLeft=px(w*0.3);
#	s.marginLeft=px(pref.sizer1*1.2);
	o=dge('cm_details').parentNode;
	o.style.height=px(h);
	var o=dge('contacts_info');
	o.style.height=px(h);
}
function cm_contact_string(c)
{
	return c_name_string(c);	
}
function cm_select_group(o,e)
{
	var arr=[];
	var el=ancestor_by_class(target(e),'cm_group');
	if(!el) return;
	if(el.parentNode.current_sel)
		class_remove(cm_row2outer(el).current_sel,'selected');	
	class_add(el,'selected');
	cm_row2outer(el).current_sel=el;
	
	id=el.getAttribute('cm_gid');
	cm_cur_group=id;
	if(cur_keep_once){
		dbg('cur_keep_once was set')
		cur_keep_once=false;
	}else{
		dbg('cur_keep_once was reset')
		cm_cur_client_cid=undefined;	
		cm_cur_server_cid=undefined;
	}
	if(id=='all'){
		for(i=0;i<address_book.data.length;i++){
			c=address_book.data[i];
			var txt=cm_contact_string(c);
			var extra=''; 
			if(c.isgroup) continue;
			if(c.webmail) extra='<div class="cm_extra" title="Old webmail addressbook entry (read only)">W</div>';
			if(c.shared) extra='<div class="cm_extra" title="Surgeweb shared addressbook entry (read only)">S</div>';
			if(!c.webmail&&!c.shared) extra='<img src="||www_base||shared/img/1pixel.gif" class="delete_contact" title="Delete contact" onclick="contact_delete(this,\''+i+'\',event)">';			
			var extra2=(c.webmail || c.shared || c.isgroup)?'':' cm_draggable';
			arr.push('<div id="cm_list_'+i+'" class="cm_contact'+extra2+'" cm_cid="'+i+'" title="'+contact_string_full(c)+'" style="background:white;"><span class="cm_right">'+extra+'</span><div style="margin-right:20px;overflow:hidden;"><div style="height:20px;width:400px; background:white;">'+txt+'</div></div></div>');
		}
	}else{
		var contacts=address_book.groups[id].contacts;
		var isfav=address_book.groups[id].name=='Favorites';
		for(i=0;i<contacts.length;i++){
			var cid=contacts[i];
			c=address_book.data[cid];
			var txt=cm_contact_string(c);
			var extra=''; 
			if(c.isgroup && address_book.groups[id].name!='Favorites') continue;
			if(c.webmail) extra='<div class="cm_extra" title="Old webmail addressbook entry (read only)">W</div>';
			else if(c.shared) extra='<div class="cm_extra" title="Surgeweb shared addressbook entry (read only)">S</div>';
			else if(isfav&&c.autofav) extra='<div class="cm_extra" title="Automatically maintained Favorite \n(frequently or recently mailed)">A</div>';
			else extra='<img src="||www_base||shared/img/1pixel.gif" class="remove_contact" title="Remove contact from group" onclick="contact_remove(this,\''+id+'\',event)">';			
			var extra2=(c.webmail || c.shared || c.isgroup)?'':' cm_draggable';
			arr.push('<div id="cm_list_'+cid+'" class="cm_contact'+extra2+'" cm_cid="'+cid+'" title="'+contact_string_full(c)+'"><span class="cm_right">'+extra+'</span><div style="margin-right:20px;overflow:hidden;"><div style="height:20px;width:400px;">'+txt+'</div></div></div>');
		}
	}
	if (arr.length==0) arr.push('<div style="padding:15px;color:#999;">There are no contacts defined in this group.<br><br>Drag and drop surgeweb contacts from this column into the left column to add contact to groups / distribution lists.</div>');
	
#	dge('cm_contacts').innerHTML='<div class="position:relative;">'+arr.join('')+'<div>';
	var nodes=dge('cm_contacts');
	nodes.innerHTML=arr.join('');
	
	var o=dge('cm_details')
	o.innerHTML=dge('contacts_info').innerHTML;
	if(o.current_sel)
		class_remove(o.current_sel,'selected');	

	dbg('*** cm_cur_client_cid='+cm_cur_client_cid);
	var resel=dge('cm_list_'+cm_cur_client_cid);
#	Go out of our way to reselect any elements that were being edited (cur_keep_once)
	if(resel){
		class_add(resel,'selected');
		cm_row2outer(resel).current_sel=resel;
		cm_contact_show(cm_cur_client_cid);
	}else if (cm_cur_server_cid){
		var c,cid;
		for(el=nodes.firstChild;el;el=el.nextSibling){
			cid=el.getAttribute('cm_cid')
			c=address_book.data[cid]
			if(c&&c.svr_id==cm_cur_server_cid){
				class_add(el,'selected');
				cm_row2outer(el).current_sel=el;
				break;
			}
			cid=undefined;
		}
		if(c&&cid) cm_contact_show(cid);
	}

	if(!(dge("cm_abookshow_personal").checked || dge("cm_abookshow_shared").checked || dge("cm_abookshow_webmail").checked))
		class_remove(o.firstChild.firstChild,'hidden');	
		
		
	var s=dge('cm_search');
	if (s.value!='' && s.value!='Search contact list...'){ s.value='Search contact list...';}

	cm_update_index();
}
function cm_row2outer(el){return el.parentNode}

function cm_select_contact(o,e)
{
#	dbg('*** QQQ cm_select_contact');
	var t=target(e);
	var el=ancestor_by_class(target(e),'cm_contact');
	dbg('target id='+t.id+' el='+el);
	
	if(!el) return;
	id=el.getAttribute('cm_cid');

	cm_cur_client_cid=id;
	dbg('*** cm_cur_client_cid='+cm_cur_client_cid+' SET')

	if(el.parentNode.current_sel)
		class_remove(cm_row2outer(el).current_sel,'selected');	
	class_add(el,'selected');
	cm_row2outer(el).current_sel=el;

#	hack_el=el;
#	dbg('*** hack_el set '+hack_el)
	cm_contact_show(id);
}

function cm_contacts_refresh(save_source,do_import)
{
	var show=[];
	if(save_source){
		show.push('pref_abook_personal='+dge('cm_abookshow_personal').checked);
		show.push('pref_abook_shared='+dge('cm_abookshow_shared').checked);
		show.push('pref_abook_webmail='+dge('cm_abookshow_webmail').checked);
		cm_cur_client_cid=undefined;
	}
	dge('cm_groups').innerHTML='Reloading...';
	dge('cm_contacts').innerHTML='Reloading contact information...';
	dge('cm_details').innerHTML=dge('contacts_info').innerHTML;
	address_book.data=[];
	address_book.groups=[];

	var data;
	data='cmd='+(save_source?'save_options,':'')+'show&page=~contacts.js';
	if (do_import) data+='&webmail_import=all';
	data+='&'+show.join('&');
	sndReqPost(data, function(chan){
		var success=actionReqJsStat(chan);			
		// TODO: Do success fail check
		if(save_source)cur_keep_once=true;
		cm_display_init();
	});		
}
function cm_display_init()
{
	contacts_init();
	cp_init();
}

function cm_contact_add2group(cid,gid)
{
    var c=address_book.data[cid];
    var group=address_book.groups[gid];
    var g_name=group.name;

	if(c.groups && c.groups.indexOf(g_name)!=-1) {
		alert(contact_string_short(c)+' is already part of the "'+g_name+'" group');
		return;
	}
	set_status('Adding to group "'+g_name+'"...',"info");
	var updated=c.groups+(c.groups.length>0?',':'')+g_name;
	contact_group_save(cid,c,updated,function(){
				set_status('Added to "'+g_name+'"',"success");
				group.contacts.push(cid);
			});
}

function contact_group_save(cid,c,groups,cb)
{
	var gs=xescape(groups);
	fields=[];	
	fields.push('server_cid='+c.svr_id+'&client_cid='+cid+'&output=one');
	fields.push('contact_groups='+(gs.length==0?'""':gs));
	fields.push('abook='+c.abook);
	
	var data;
	data='cmd=contact_update,show&page=~contacts.js';
	data+='&'+fields.join('&');
	sndReqPost(data, function(chan){			
		var success=actionReqJsStat(chan);			
		cb();
		cm_display_init();
	});
}


function contact_delete(el,id,e)
{
	if (!id){
		el=ancestor_by_class(el,'cm_contact');
		id=el.getAttribute('cm_cid')
	}
	var c=address_book.data[id];

	x_confirm('Are you sure you want to permanently delete the contact information for '+contact_string_short(c)+' from all groups?', function(n){
		if(!n)return;
		var fields=[];	
		fields.push('server_cid='+c.svr_id+'');	
		var data;
		data='cmd=contact_delete,show&page=~contacts.js&abook='+c.abook;
		data+='&'+fields.join('&');
		sndReqPost(data, function(chan){			
			cm_reset_abook(true)
			var success=actionReqJsStat(chan);			
			cm_display_init();
		});
	});
	if(e){
		stopEvent(e);
		return false;
	}
}

# cf cm_contact_add2group
function contact_remove(el,gid,e)
{
	el=ancestor_by_class(el,'cm_contact');
	cid=el.getAttribute('cm_cid')
	c=address_book.data[cid];
    var group=address_book.groups[gid];
    var g_name=group.name;

	set_status('Removing '+contact_string_short(c)+' from group "'+g_name+'"...',"info");

	var tmp=c.groups.split(',');
	for(var i=0;i<tmp.length;i++){
		if (tmp[i]==g_name)
			tmp.splice(i,1);
	}
	contact_group_save(cid,c,tmp.join(','),function(){
				set_status(contact_string_short(c)+' removed from  '+g_name,"success");
				var tmp = group.contacts;
				for(var i=0;i<tmp.length;i++){
					if (tmp[i]==cid)
						tmp.splice(i,1);
				}
				cm_display_init();
			});
	stopEvent(e);
	return false;
}


# probably want to combine this with the first similar function 
function contact_search2_clear(ctl,e)
{
	if(ctl.value.indexOf("Quick search") != -1){
		ctl.value="";
	}
}
function contact_search2_reset(ctl,e)
{
	if(ctl.value==''){
		ctl.value="Search contact list...";
	}
}
function contact_search3_clear(ctl,e)
{
	if(ctl.value.indexOf("Search contact list...") != -1){
		ctl.value="";
	}
}
function contact_search2_do(ctl,e)
{
	setTimeout(function(){contact_search2_real(ctl)},10);
}
function contact_search2_real(ctl)
{
	var match=ctl.value.toLowerCase();
	var contacts=dge("cm_contacts");
	class_add(contacts,'hidden');
	if(contacts.current_sel)
		class_remove(contacts.current_sel,'selected');	
	for(row=contacts.firstChild;row;row=row.nextSibling){
		x=row.innerHTML.toLowerCase();
        if(x.indexOf(match) != -1){
            class_remove(row,"hidden");
        }else{
	        class_add(row,"hidden");
        }
    }
	cm_index_select(dge("cm_index").firstChild);
	dge("cm_details").innerHTML="";
	class_remove(contacts,'hidden');
}


function contact_new_group()
{
	x_prompt('Create new group :','new group name',function(val){
		if(!val) return;
		var extra='&contact_name='+xescape(val)+'&group=true';
		sndReq('cmd=contact_add,show&page=~contacts.js'+extra, function(chan){
			cm_reset_abook(true)
			var success=actionReqJsStat(chan);
			if(!success){
				set_status('Contact save failed ('+success_string+')','warning');
				cm_restore_abook();
			}else{
				set_status('Group "'+val+'" added to addressbook','success');
				cm_display_init();
			}
		});
	});
}
# cf contact_delete(el,id)
function contact_delete_group(id,el,name,e)
{
	var g=address_book.groups[id];
	x_confirm('Are you sure you want to permanently delete the contact group "'+g.name+'" ? <br>Note: actual contact information will not be deleted',function(n){
		if(!n)return;
		var extra='&server_cid='+g.svr_id+'&contact_isgroup=true&contact_name='+xescape(g.name);
		sndReq('cmd=contact_delete,show&page=~contacts.js'+extra, function(chan){
			cm_reset_abook(true)
			var success=actionReqJsStat(chan);
			if(!success){
				set_status('Contact save failed ('+success_string+')','warning');
				cm_restore_abook();
			}else{
				set_status('Group "'+name+'" deleted','success');
				cm_display_init();
			}
		});
	});
	stopEvent(e);
	return false;
}



function do_contact_edit(id)
{
# 	For now we are always getting full addressbok data from the server, if that becomes unmanageable, then should normally only retrieve 
# 	the core fields of name, email, group & id, then only retrieve Full data on demand when required.
	c=address_book.data[id];

	cm_contact_edit(c,id);
}

||ifdef||_junk_||
# Fields we have:
										Phonetic-3F					<< phonetic (3)		
Pic		FirstName LastName				+Prefix Middle Suffix		<< name		(5)
										Nickname					<< nickname
										Title Department			<< company	(3)
		Company													
		FileByCo													<< file_by

																	<< picture

										MaidenName					<< mainden_name

		phone (x2 - home,mobile)									<< phone [x]
		
		email (x1)													<< email [x]
		
		IM KIND (x1)												<< messenger [x]

										URL (x1)					<< url [x]
										
										Birthday					<< birthday
										
										Anniversary (x1)			<< anniversary [x]
										
										Associates (x1)				<< associates [x]
				
		Address-5F (x1)												<< addess [x] (5?)
										
										** Custom (x1)				<< custom [x]
		
		Note														<< note



phonetic (3)		
name	(5) *first, middle, *last, prefix, suffix
nickname
company	(3) title, dept, *company
file_by
*picture

maiden_name, *phone [x], *email [x], *messenger [x], url [x], birthday, anniversary [x], associates [x], 
*addess [x] (5?), custom [x], *note

# DB definition:
#	need fancy db value as soon as:
#		- have several instances 	
#		- type / value pair
#		- multiple value field


||endif||		
# Interface groupings that can be separately enabled, Separately enableable . Moslty a '1 to 1' mapping to database fields,
#  but in a few cases the mapping is '1 to n' or 'n to 1' to the database fields 
var CFD={
	'prefix':{hint:{'value':'Prefix'}, showdef:false, xblank:['name','prefix']},
	'name':{hint:{'first':'First Name','last':'Last Name'}, reload:true, showdef:true, blank:{first:'',last:''}},
	'phonetic':{hint:{'first':'Phonetic First Name','last':'Phonetic Last Name'}, blank:{first:'',last:''}},
	'suffix':{hint:{'value':'Suffix'}, xblank:['name','suffix']},
	'title':{hint:{'value':'Job Title'}, xblank:['company','title']},
	'department':{hint:{'value':'Department'}, xblank:['company','department']},
	'company':{hint:{'value':'Company'}, reload:true, showdef:true, blank:{value:''}},
	'file_by_co':{hint:{'value':'File by company'}, reload:true, plain:true, showdef:true, edit:'checkbox', blank:''},

	'other_names':{ hint:{'value':'Other Name'}, multi:true, desc:'nickname,maiden name,middle name', blank:[{type:'other name',value:''}]},

	'phone':{hint:{'value':'Phone Number'}, showdef:true, multi:true, desc:'work,home,mobile,fax,pager', blank:[{type:'home',value:''},{type:'work',value:''}]},
	'email':{hint:{'value':'Email address'}, showdef:true, multi:true, desc:'work,home,other', blank:[{type:'home',value:''}] },
	'im':{hint:{'value':'Instant Messenger'}, multi:true, desc:'work,home,other', blank:[{type:'home',value:'',network:'msn'}] , extra:extra_field_im},
	'url':{hint:{'value':'URL'}, multi:true, desc:'home page,blog,work', blank:[{type:'home page',value:''}] },

	'birthday':{hint:{'value':'Date'}, plain:true},
	'dates':{hint:{'value':'Date'},multi:true, desc:'anniversary',blank:[{type:'anniversary',value:''}] },
	'related_names':{hint:{'value':'Related Name'},multi:true, desc:'friend,father,mother,son',blank:[{type:'friend',value:''}] },

	'address':{hint:{'value':'Address'}, showdef:true, multi:true, edit:'textarea', desc:'work,home,other', blank:[{type:'home',value:''}] },
	'custom':{hint:{'value':'Custom'}, multi:true, desc:'custom,any,thing,you,want', blank:[{type:'custom',value:''}]},
	'comment':{hint:{'value':'Comment'}, plain:true, showdef:true, edit:'textarea'},
	'groups':{hint:{'value':'Groups'}, plain:true, showdef:false, showdef_shared:true, refresh_warn:true, blank:''}
};
var CFD_list=[	{address:'Address'},{birthday:'Birthday'},{comment:'Comment'},{company:'Company'},{custom:'Custom Fields'},{dates:'Dates'},{department:'Department'},
				{email:'Email'},{im:'Instant Messenger'},{title:'Job Title'},{other_names:'Maiden Name'},{other_names:'Middle Name'},{name:'Name'},{other_names:'Nickname'},
				{phone:'Phone'},{phonetic:'Phonetic Names'},{prefix:'Prefix'},{address:'Address'},{related_names:'Related Names'},{suffix:'Suffix'},{url:'URL'}];

var explicitly_enabled=false,data_enabled=false;
function workout_fields_toshow(c,type)
{
	var cfd, k, kk;
	for (k in CFD){ 
		CFD[k].show=false;
	}
	for (k in CFD){
		cfd=CFD[k];
		if(cfd.showdef && type=='edit') {
			cfd.show=true;
		}else if(cfd.showthis && type=='edit'){
			cfd.show=true;
		}else if(cfd.showdef_shared){
			if(!c.shared){
				cfd.show=false;
			}else if (type=='edit'){
				cfd.show = true;
			}else if (c[k]){
				cfd.show = true;
			}
		}else if(true){
# also see hookup_fields
			if (cfd.xblank){
				kk=cfd.xblank[0];
				if(c[kk] && c[kk][cfd.xblank[1]])
					cfd.show=true;
			}else{
				for(kk in cfd.hint){
					if(c[k] && c[k][kk])	
						cfd.show=true;
					if(cfd.multi && c[k] && c[k][0] && c[k][0][kk])	
						cfd.show=true;
					if(cfd.plain && c[k])	
						cfd.show=true;
				}
			}
#			for (f in c){ 
#				if(CFD[k].showdef) CFD[k].show=true;
#			}
		}else{
			cfd.show=false;
		}		
	}

}


function contact_tr(arr,desc,edit,c1_extra)
{
	arr.push('<div class="tcell1"'+c1_extra+'>'+desc+'</div><div class="tcell2">'+edit+'</div>')
	
}
var ctl_xevents=[' onchange="cctl_change(this,event)"', ' onfocus="cctl_focus(this)"', ' onblur="cctl_blur(this)"', ' onkeyup="cctl_keyup(this,event)"'];
var ctl_events = ctl_xevents.join('');
function new_field(c,field,cfd)
{
	if(!c) c=sw.curr_contact;
	if(c[field] && c[field].length>0){
		c[field].push(cloneObject(cfd['blank'][0]));
	}else{
		var o = cloneObject(cfd['blank'])
#		if(is_array(o)||!cfd['multi'])
			c[field]=o;
#		else
#			c[field]=[o];
	}
}
function new_field_create(field)
{
	var cfd=CFD[field];
	new_field(undefined,field,cfd);
	cm_contact_edit(sw.curr_contact,sw.curr_contact_id);
}
function field_remove(ctl,field,i)
{
	var c=sw.curr_contact;
	if(c[field].length>1)
		c[field].splice(i,1);
	else
		c[field][0]['value']='';
	cm_contact_edit(c,sw.curr_contact_id);
}
function confirm_exist(c,field)
{
	var cfd=CFD[field];
	if(cfd.xblank){
		var real_field=cfd.xblank[0];
		var xcfd=CFD[real_field];
		if(!c[real_field]){
			new_field(c,real_field,cfd);
		}
		if(!c[real_field][cfd.xblank[1]])
			c[real_field][cfd.xblank[1]]='';
		return;
	}
	if(!c[field]){
		new_field(c,field,cfd);
	}
}
function output_section(arr,c,field,edit,cfd)
{
	var donesome=false, output;
	if(!c[field] || c[field].length==0){
		if (!cfd['show']) return;
		new_field(c,field,cfd);
	}
	arr.push('<div id="cb_'+field+'" class="box">')
	for(i=0;i<c[field].length;i++){
		var xx=c[field][i];
		if (!edit && xx['value']=='') continue;
		if(!edit){
			if(field=='email'){ 
				output='<a href="#" onclick="do_contact_email2('+sw.curr_contact_id+',\''+val(xx,'value')+'\')" class="link_blue" >'+val(xx,'value')+'</a>';
			}else if(field=='url'){ 
				output='<a href="'+val(xx,'value')+'" target="_popup" class="link_blue" >'+val(xx,'value')+'</a>';
			}else if(cfd['edit']=='textarea'){ 
				output='<a href="http://maps.google.com/maps?q='+val(xx,'value').replace(/[\r\n ]+/g,'+')+'" title="Show map using Google Maps" class="link_black" target="_popup">'+val(xx,'value').replace(/[\r\n]+/g,'<br>')+'</a>';
			}else{ 
				output=val(xx,'value');
			}
			contact_tr(arr,	'<span id="contact_'+field+'_'+i+'_type">'+val(xx,'type')+'</span>',output+(cfd.extra?cfd.extra('show',xx):''));
		}else{	
			var type_click=	' onmousedown="contact_type_menu(this,event)" onclick="return stopEvent(event)" field="'+field+'"';
			var type=	'<img class="xtype" src="||www_base||shared/img/1pixel.gif">';
			var btns=	'<a class="hidden" onclick="field_remove(this,\''+field+'\','+i+')"><img class="xclosetab" src="||www_base||shared/img/1pixel.gif" ></a>'+
						'<a class="hidden" onclick="new_field_create(\''+field+'\')""><img class="xaddtab" src="||www_base||shared/img/1pixel.gif" ></a>';
			if(cfd['edit']=='textarea'){
				contact_tr(arr,	'<span id="contact_'+field+'_'+i+'_type" unselectable="on"></span>'+type,
								'<span><textarea id="contact_'+field+'_'+i+'" rows=4 class="cm_edit" '+ctl_events+'>'+val(xx,'value')+'</textarea></span>'+btns,
								type_click);	
			}else{
				contact_tr(arr,	'<span id="contact_'+field+'_'+i+'_type" unselectable="on"></span>'+type+'',
								'<span><input type="text" id="contact_'+field+'_'+i+'"'+ctl_events+'>'+(cfd.extra?cfd.extra('edit'):'')+'</span>'+btns,
								type_click);
			}
			// Messes up dependencies in hookup_field
		}
		donesome=true;
	}
	if(donesome)
		arr.push('</div>')
	else
		arr.pop();
}
function output_field(arr,c,field,edit,cfd)
{
	if (!c[field] ||  c[field].length==0){
		if (!cfd['show']) return;
		c[field]='';
	}
	var xx=c[field];
	arr.push('<div id="cb_'+field+'" class="box">');
	if (!edit && xx['value']=='') return;
	if(!edit){
		if(cfd['edit']=='textarea')
			contact_tr(arr,field,'<span id="contact_'+field+'">'+val(xx,'value').replace(/[\r\n]+/g,'<br>')+'</span>');	
		else
			contact_tr(arr,field,'<span id="contact_'+field+'">'+val(xx,'value')+'</span>');
	}else{
		if(cfd['edit']=='textarea')
			contact_tr(arr,field,'<textarea id="contact_'+field+'" rows=4 class="cm_edit" '+ctl_events+'>'+val(xx,'value')+'</textarea>');	
		else
			contact_tr(arr,field,'<input type=txt id="contact_'+field+'"'+ctl_events+'>');	
	}
	arr.push('</div>');
}

function output_myfields(arr,c,field,edit)
{
	var cfd=CFD[field];
#	if (!cfd) return;
	if (!cfd || !(cfd.show || cfd.showdef)) return;
	
	if(cfd['multi']){
		output_section(arr,c,field,edit,cfd);
	}else{
		output_field(arr,c,field,edit,cfd);
	}
}
function format_boxes()
{
	for (k in CFD){
		if(CFD.xblank) continue;
		format_box(k);
	}
}
function format_box(el)
{
	if(is_string(el)){
		el=dge('cb_'+el);
	}
	if(!el) return;
	panelise_round(el,enBoth);
	var outer=panel_correct(el);
	outer.style.width=px(450);
	class_add(outer,'grouping');
}

# Hookup editable fields to backing data object, set initial value of fields from data object,
# and cache any special divs we need for tweaking the interface
function hookup_fields(c)
{
	for (field in CFD){
		if (field=='file_by_co') continue;
		var cfd=CFD[field];
		if(cfd.xblank){
			var real_field=cfd.xblank[0];
			var xcfd=CFD[real_field];
			if(c[real_field][cfd.xblank[1]]==undefined) continue;
			hookup_field(c[real_field],field,cfd,real_field);	
			continue;
		}
		if(c[field]==undefined) continue;
		if(is_array(c[field])){
#			Repeat for each instance of multi-instance fields
			for(i=0;i<c[field].length;i++){
				hookup_field(c[field][i],field,cfd);
			}
		}else{
			if(cfd.plain){
				hookup_field(c,field,cfd);	
			}else{
				hookup_field(c[field],field,cfd);	
			}
		}
	}
}
#Hookup one multivalue object / or string to its edit fields
function hookup_field(xvalue,field,cfd,real_field)
{
	var xid;

#	Get actual edit control
	for(var k in cfd['hint']){
		var hint=cfd['hint'][k];
		var id=field;

		if(cfd.xblank){
			k=cfd.xblank[1];
			id=real_field;
		}
		if(k!='value')id+='_'+k;
		if(cfd['multi']) id+='_'+i;
		var o=dge('contact_'+id);
		if(!o) return;

		if(cfd.extra) cfd.extra('hookup',xvalue,o);

#	... and initialise it
		o.hint=hint;
		o.store=xvalue;
		o.store_type=cfd.plain?field:k;
		o.reload=cfd.reload;
	
#	Initialise controls for multiinstance values	
		if(cfd['multi']){
			o.div_del=abook_field2divdel(o);
			o.div_more=o.div_del.nextSibling;
		}
# 	Initialise the left hand type/descriptor field if required
		if(cfd['desc'] && !xid){
			var xid=field;
			if(cfd['multi']) xid+='_'+i;
			var t=dge('contact_'+xid+'_type');
			t.store=xvalue;
			t.store_type='type';
			o.div_type=t;
		}

#	Make sure ctl is in a valid state
		cctl_edit_start(o);
		cctl_value_init(o);
		if(xvalue[k]==''){
			cctl_edit_done(o);
		}
	}
}




function cm_contact_show(id)
{
	var c=address_book.data[id];

	if(!c.full){
		dge('cm_details').innerHTML='<div style="padding:20px;color:#666;">Retrieving contact details...</div>';
		sndReq('cmd=show&page=~contacts.js&output=one&server_cid='+xescape(c.svr_id)+'&client_cid='+id+'&abook='+xescape(c.abook), function(chan){
			var success;
			try{
				success=actionReqJsStat(chan);
			} catch (ex) {
				contact_error();
			}

			if(success){
				cm_contact_show(id);
			}
		});
		return;
	}

	cm_cur_server_cid=c.svr_id;

	var editable=contact_editable(c);

	var arr=[];
	
	sw.curr_contact=c;
	sw.curr_contact_id=id;

	var co_first=c.file_by_co;
	var primary_fields=[];
	
	
	var txt_sizing='font-size:20px;';

	workout_fields_toshow(c,'show');

	if (c.shared) arr.push('<div class="cm_info" style="margin:7px 40px 0px 40px;text-align:center;">Shared address book entry ('+c.abook+') - <i> '+(editable?'EDITING PERMITTED':'READ ONLY')+'</i></div>');
	
	if (c.webmail) arr.push('<div class="cm_warning" style="margin:7px 40px 0px 40px;text-align:center;" title="Edit using webmail or import if you want to change them">Webmail contact information is read only. <a href="#" onclick="webmail_import('+id+')">Import this contact</a>, <a href="#" onclick="webmail_import(\'all\')">all webmail contacts</a></div>');


	arr.push('<div style="padding:'+(c.shared?'0':'20px')+' 20px 20px 20px;">')
	if(c['invalid']==true){
		arr.push('<div class="cm_warning">Some contact information may be missing due to past software bug, please make any corrections and resave...</div>')
	}
	if(pref.devt_mode){
		arr.push('client_id='+id+' server_id='+val(c.svr_id)+'<br><br>')	
		arr.push('groups='+val(c.groups)+'<br>')	
	}
	arr.push('<div class="contact_show" style="padding:20px;">')

	if (c.file_by_co){
		output_primaryfield(c,primary_fields,'company',(c['company']?'<span  style="'+txt_sizing+'">'+val(c['company'].value)+'</span>':''));
		txt_sizing='';
	}	
	output_primaryfield(c,primary_fields,'phonetic',(c['phonetic']?'<span style="font-style:italic">('+val(c['phonetic'].first)+' '+val(c['phonetic'].last):'')+')</span>');
#	primary_fields.push((c['name']?'<span  style="'+txt_sizing+'">'+val(c['name'].prefix)+' '+val(c['name'].first)+' '+val(c['name'].last)+'</span> '+val(c['name'].suffix):'<i style="color:#888;'+txt_sizing+'">No name specified</i>'));
	primary_fields.push((c_name(c)!=''?'<span  style="'+txt_sizing+'">'+val(c['name'].prefix)+' '+val(c['name'].first)+' '+val(c['name'].last)+'</span> '+val(c['name'].suffix):'<span style="'+txt_sizing+'">'+c_email(c)+'</span>'));
	var tmp=[]
	output_primaryfield(c,tmp,'title',(c['company']?'<span>'+val(c['company'].title):'')+'</span>');
	output_primaryfield(c,tmp,'department',(c['company']?'<span>'+val(c['company'].department):'')+'</span>');
	if(tmp.length>0)
		primary_fields.push(tmp.join(' - '));
	if (!c.file_by_co)
		output_primaryfield(c,primary_fields,'company',(c['company']?'<span >'+val(c['company'].value)+'</span>':''));

	arr.push('<table><tr><td style="width:90px;">');
	arr.push('<div style="text-align:center;"><img src="||www_base||shared/img/no_picture.gif" height=50 width=50 style="border:1px solid #999;"></div>');
	arr.push('</td><td>');
	arr.push(primary_fields.join('<br>'));
	arr.push('</td></tr></table>');


	output_myfields(arr,c,'phone');
	output_myfields(arr,c,'email');
	output_myfields(arr,c,'im');
	output_myfields(arr,c,'url');
	output_myfields(arr,c,'other_names');
	output_myfields(arr,c,'birthday');
	output_myfields(arr,c,'dates');
	output_myfields(arr,c,'related_names');
	output_myfields(arr,c,'address');
	output_myfields(arr,c,'custom');
	output_myfields(arr,c,'comment');

	output_myfields(arr,c,'groups');

	arr.push(' <input type=button onclick="do_contact_email('+id+')" value="Email Contact">');
	if(editable) arr.push(' <input type=button onclick="do_contact_edit('+id+')" value=" '+(c.shared?'Edit Shared Contact':'Edit Contact')+'">');
	if(!editable){
#		if (c.webmail) 
#			arr.push('<div class="cm_warning" style="margin-top:7px" title="Edit using webmail or import if you want to change them">Webmail contact information is read only. <a href="#" onclick="webmail_import('+id+')">Import this contact</a>, <a href="#" onclick="webmail_import(\'all\')">all webmail contacts</a></div>');
#		else	
#			arr.push('<div class="cm_warning" style="margin-top:7px" title="Contact your system administrator if you need edit permission">Not allowed to edit the shared contacts ('+c.abook+')</div>');
	}

	if(false){
		arr.push('<div style="margin-top:25px">The [email address | name] of this entry matches another contact. Do you wish to <a href="#">merge these contacts</a>?</div>');
	}


# *** old stuff ***
  if(false){
	arr.push('<br><br><br>')
	arr.push('<div style="font-size:14px;font-weight:bold"> Contact: '+contact_string_short(c)+'</div>');
	arr.push('<div>')
	if(c.isgroup)
		contact_tr(arr,'isgroup',c.isgroup);
	contact_tr(arr,'Name:',c_name(c));
	contact_tr(arr,'Email:',c_email(c));
	contact_tr(arr,'Groups:',val(c.groups));
	arr.push('</div>');
	arr.push('</div>');
  }
# *** old stuff end ***

	arr.push('</div>')
	dge('cm_details').innerHTML=arr.join('');

	format_boxes();
}
function cm_contact_edit(c,id)
{
	var heading,arr=[],new_contact;
	dge('cm_details').innerHTML='';
	if (!c) {
		c=new Object;
		heading='New Contact';
		new_contact=true;
		c.svr_id='new';
		c.abook=abook_new;
		if (c.abook!='User') c.shared=true;
		abook_new='User';
	}else{
		heading=contact_string_short(c);
	}
	sw.curr_contact=c;
	sw.curr_contact_id=id;

	confirm_other_names(c)
	
	var cm_details=dge('cm_details');
#	Make sure the screen updates are "nice" on firefox
	class_add(cm_details,'hidden');
	cm_details.scrollTop=0;

	if (c.shared) arr.push('<div class="cm_warning" style="margin:7px 40px 0px 40px;text-align:center;">Editing shared address book entry ('+c.abook+')</div>');

	arr.push('<div style="padding:'+(c.shared?'0':'20px')+' 20px 20px 20px;">')
	if(pref.devt_mode){
		arr.push('client_id='+val(id)+' server_id='+val(c.svr_id)+'<br><br>')	
		arr.push('groups='+val(c.groups)+'<br>')	
	}
	arr.push('<div class="contact_edit" style="padding:20px;">')

	workout_fields_toshow(c,'edit');

	var primary_fields=[];
	var txt_sizing=' style="font-size:20px"';

	if (c.file_by_co){
		output_primaryfield(c,primary_fields,'company','<input id="contact_company"'+txt_sizing+ctl_events+'>',true);
		txt_sizing='';
	}	
	output_primaryfield(c,primary_fields,'prefix','<input id="contact_name_prefix"'+ctl_events+'>',true);
	output_primaryfield(c,primary_fields,'phonetic','<input id="contact_phonetic_first"'+ctl_events+'>&nbsp;<input id="contact_phonetic_last"'+ctl_events+'>',true);
	output_primaryfield(c,primary_fields,'name','<input id="contact_name_first"'+txt_sizing+ctl_events+'>&nbsp;<input id="contact_name_last"'+txt_sizing+ctl_events+'>',true);
	output_primaryfield(c,primary_fields,'suffix','<input id="contact_name_suffix"'+ctl_events+'>',true);
	var tmp=[]
	output_primaryfield(c,tmp,'title','<input id="contact_company_title"'+ctl_events+'>',true);
	output_primaryfield(c,tmp,'department','<input id="contact_company_department"'+ctl_events+'>',true);
	if(tmp.length>0)
		primary_fields.push(tmp.join('&nbsp;'));
	if (!c.file_by_co)
		output_primaryfield(c,primary_fields,'company','<input id="contact_company"'+ctl_events+'>',true);
	primary_fields.push('<input type="checkbox" id="contact_file_by_co"'+(c.file_by_co?' checked':'')+' onclick="toggle_file_by_co(this)"> File by company');

	arr.push('<table><tr><td style="width:90px;">');
	arr.push('<div style="text-align:center;"><img src="||www_base||shared/img/no_picture.gif" height=50 width=50 style="border:1px solid #999;"><br><a href="#" onclick="alert(\'image addition will be implemented soon\')">Add</a></div>');
	arr.push('</td><td>');
	arr.push(primary_fields.join('<br>'));
	arr.push('</td></tr></table>');

	output_myfields(arr,c,'phone',true);
	output_myfields(arr,c,'email',true);
	output_myfields(arr,c,'im',true);
	output_myfields(arr,c,'url',true);
	output_myfields(arr,c,'other_names',true);
	output_myfields(arr,c,'birthday',true);
	output_myfields(arr,c,'dates',true);
	output_myfields(arr,c,'related_names',true);
	output_myfields(arr,c,'address',true);
	output_myfields(arr,c,'custom',true);
	output_myfields(arr,c,'comment',true);
	output_myfields(arr,c,'groups',true);	

	arr.push('<input type="button" value="Save" onclick="contact_edit_save('+id+')">')
	if(!new_contact)
		arr.push(' <input type="button" value="Delete" onclick="contact_delete(undefined,'+id+')">');
	arr.push(' <input type="button" value="Cancel" onclick="contact_edit_cancel('+id+')">')
	arr.push('&nbsp;&nbsp;');
	arr.push(' <input type="button" value="Additional fields..." onclick="contact_fields_add('+id+',event)">')

	arr.push('<input type=hidden id="contact_svr_id" value="'+val(c.svr_id)+'">');

# *** old stuff ***
  if(false){
	arr.push('<br><br>');
	arr.push('<div style="font-size:14px;font-weight:bold"> Contact: '+heading+' </div>');
	arr.push('<div>')
	contact_tr(arr,'Name:', '<input type="text" id="contact_name" value="'+c_name(c)+'">');
	contact_tr(arr,'Email:','<input type="text" id="contact_email" value="'+c_email(c)+'">');
	contact_tr(arr,'Groups:','<input type="text" id="contact_groups" value="'+val(c.groups)+'">');	
	arr.push('</div>');
#	arr.push('</div>');
  }else{
	arr.push('<input type=hidden id="contact_name" value="'+c_name(c)+'">');
	arr.push('<input type=hidden id="contact_email" value="'+c_email(c)+'">');
	if(!c.shared)
		arr.push('<input type=hidden id="contact_groups" value="'+val(c.groups)+'">');
  }
# *** old stuff end ***
	arr.push('</div>')
	cm_details.innerHTML=arr.join('');
# 	Complete form fields initialisation
	hookup_fields(c);
	format_boxes();

	class_remove(cm_details,'hidden');
}

function confirm_other_names(c)
{
	var add=true;
	if(!contact_check_add) return;
	var field='other_names';
	
#	if(!c.other_names)
#		new_field(c,'other_names,cfd)

	var q=sw.curr_contact[field];
	for (var j=q.length-1;j>=0;j--){
		if(q[j].type==contact_check_add)
			add=false;
	}
	if(add){
		new_field(undefined,field,CFD[field]);
		q[q.length-1].type=contact_check_add;
	}

	contact_check_add=undefined;
}
function output_primaryfield(c,arr,type,txt,edit)
{
	if(!edit){
		if (CFD[type].show)
			arr.push(txt);			
		return;
	}
	if(CFD[type].show || type=='name' || type=='company'){
		arr.push(txt);
		confirm_exist(c,type);
	}
}
function contact_edit_save(id)
{
	// bit like contact_click & contact_group_save but have whole contacts object serialised
	var c=sw.curr_contact;
	var full=c.reload && keep_sorted;
	
	fields=[];	
	if(c.file_by_co && !c.company.value)
		c.file_by_co='';

	var server_cid=dge('contact_svr_id').value;
	fields.push('server_cid='+server_cid);
	fields.push('client_cid='+(full?'':val(id)));
	fields.push('output='+(full?'all':'one'));
	
	for (k in CFD){
		field=CFD[k];
		if (field.xblank) continue;
		if (!c[k] && c[k]!='') continue;
		fields.push('contact_'+k+'='+xescape(serialise(c[k],true,field.plain)));
	}

	fields.push('abook='+c.abook);
	
	var data;
	data='cmd=contact_update,show&page=~contacts.js';
	data+='&'+fields.join('&');
	sndReqPost(data, function(chan){			

#		As we are getting all data back, remove original data for now.
		//error check this response!!!

		if(full){
			cm_reset_abook()
		}else if(server_cid=='new'){
			cm_cur_client_cid=address_book.data.length;
			cm_cur_group=1;
		}
		cur_keep_once=true;
		var success=actionReqJsStat(chan);			
		cm_display_init();
	});
}

function contact_edit_cancel(id)
{
	if (!id) return cm_contacts_refresh(false);
	address_book.data[id].full=false;
	cm_contact_show(id);
}

#cf "contact_fields_add
function contact_type_menu(ctl,e)
{
	var t=ancestor_by_att(target(e),'field')
	if (!t) return;
	var type_div=t.firstChild;
	var m=contact_fields_menu(t.getAttribute('field'));
	m.type_div=type_div;
	do_menu_show('ed_menu_'+'type',e,true,function(){remove_node(dge('ed_menu_'+'type'));},{right:true,xoffset:15,yoffset:dge('cm_details_scrolled').scrollTop-3});
}
function contact_fields_add(id,e)
{
	var m=contact_fields_menu('contacts');
	do_menu_show('ed_menu_'+'contacts',e,true,function(){remove_node(dge('ed_menu_'+'contacts'));},{upwards:true,yoffset:dge('cm_details_scrolled').scrollTop});
}


function contact_fields_menu(id)
{
	var arr=[];
	var o=dge('ed_menu_'+id);
	var show;
	if (!o){
		var o=document.createElement("div");
		o.className = 'xmenu';
		if (id=='contacts'){
			o.onmouseup=contact_select_fields;
			for (var i=0;i<CFD_list.length;i++){
				for(k in CFD_list[i]){
					show=CFD[k]['show'];
					if(k=='other_names'){
						show=false;
						var q=sw.curr_contact.other_names;
						if(!q) continue;
						for (var j=q.length-1;j>=0;j--){
							if(q[j].type==CFD_list[i][k].toLowerCase())
								show=true;
						}
					}
					arr.push('<a href="#" class="fontname" style="'+(show?'color:#777;':'font-weight:bold;')+'padding:0 3px;" param="'+k+'">'+CFD_list[i][k]+'</a>');
				}
			}
		}else{
			o.onmouseup=contact_select_type;
			var tmp=CFD[id].desc.split(',');
			for(var i=0;i<tmp.length;i++){
				arr.push('<a href="#" class="fontname" style="padding:0 15px 0 5px;" >'+tmp[i]+'</a>');
			}
			arr.push('<a href="#" style="padding:0 15px 0 5px;" disabled>&nbsp;</a>');
			arr.push('<a href="#" class="fontname" style="padding:0 15px 0 5px;">custom...</a>');
			id='type';
		}
		o.innerHTML='<div style="font-size:12px">'+arr.join('')+'</div>';
		o.id = 'ed_menu_'+id;

		o.onmouseout=function(e){if(!e) e=window.event; menu_action_mouseout(e,o.id)}; 
		o.onmouseover=function(e){if(!e) e=window.event; menu_action_mouseover(event,o.id)};
		document.body.appendChild(o);
	}
	return o;
}
var contact_check_add;
function contact_select_fields(e)	// cf ed_click
{
	if(!e) e=window.event;
	var t=target(e);
	var field=t.getAttribute("param");
#	alert(t.getAttribute("param"))
	menu_delete('ed_menu_'+'contacts')
	CFD[field]['showthis']=true;
	if(field=='other_names') contact_check_add=t.innerHTML.toLowerCase();
	
	cm_contact_edit(sw.curr_contact,sw.curr_contact_id);
}
function contact_select_type(e)
{
	if(!e) e=window.event;
	var t=target(e);
#	var field=t.getAttribute("param");
	menu_delete('ed_menu_'+'type')
	var type_div=pparent(t).type_div;
	var txt=t.innerHTML;
	if (txt=='custom...') return alert('custom types will be implemented soon')
	type_div.store[type_div.store_type]=txt;
	cm_contact_edit(sw.curr_contact,sw.curr_contact_id);
}


# Fancy conctrol used on the contacts page
function cctl_focus(ctl){cctl_edit_start(ctl);}
function cctl_blur(ctl){cctl_edit_done(ctl);}
function cctl_change(ctl,e){ cctl_propagate_value(ctl); }
function cctl_keyup(ctl,e){ cctl_value_based_update(ctl); }

# Actual implementation functions
function cctl_value_init(ctl)
{
	if(ctl.div_type){
		ctl.div_type.innerHTML=val(ctl.div_type.store[ctl.div_type.store_type]);
	}
	ctl.value=val(ctl.store[ctl.store_type]);

	if (ctl.div_del && (ctl.valid && ctl.value.length>0 || abook_outer2prev(abook_field2outer(ctl))))
		class_remove(ctl.div_del,'hidden');

	if(ctl.value.length>0){
		if(ctl.div_more && !abook_outer2next(abook_field2outer(ctl)))
			class_remove(ctl.div_more,'hidden');
	}

	cctl_edit_done(ctl);
}
var refresh_warned;
function cctl_propagate_value(ctl)
{
	if (!ctl.store)return;

	ctl.store[ctl.store_type]=ctl.value;
	
	if(CFD[ctl.store_type] && CFD[ctl.store_type].refresh_warn && !refresh_warned){
		setTimeout(function(){
				refresh_warned=true;
				x_alert('Contact groups manually modified, refresh contacts to make sure group list in left pane is up-to-date. (this warning is only shown once per session)')
		},0);
	}
	
	if(ctl.reload)
		sw.curr_contact.reload=true;
}
function cctl_edit_start(ctl)
{
	if(!ctl.valid){
		ctl.value='';
	}
	ctl.valid=true;
	class_remove(ctl,'invalid')
	class_add(ctl,'valid')
}
function cctl_edit_done(ctl)
{
	if(ctl.value.length==0){
		ctl.valid=false;
		ctl.value=ctl.hint;
		class_remove(ctl,'valid')
		class_add(ctl,'invalid')
	}
}
function cctl_value_based_update(ctl)
{
	if(!ctl.div_del) return;
	if(ctl.value.length>0){
		class_remove(ctl.div_del,'hidden');
		if(!abook_outer2next(abook_field2outer(ctl)))
			class_remove(ctl.div_more,'hidden');
	}else{
#		class_add(ctl.div_del,'hidden');
		class_add(ctl.div_more,'hidden');
	}
}

function toggle_file_by_co(ctl)
{
	sw.curr_contact.file_by_co=!sw.curr_contact.file_by_co;
	sw.curr_contact.reload=true;	
	cm_contact_edit(sw.curr_contact,sw.curr_contact_id);
}
# cf contact_search2_real
function cm_index_click(e)
{
	var id;
	t=target(e);
	if(!class_contains(t,'cm_present')) return;
	var match=t.innerHTML;

	cm_index_select(t);

	var contacts=dge("cm_contacts");
	class_add(contacts,'hidden');
	if(contacts.current_sel)
		class_remove(contacts.current_sel,'selected');	


	for(row=contacts.firstChild;row;row=row.nextSibling){
		id=row.getAttribute('cm_cid');
		c=address_book.data[id];        
        if(match=='all' || (c && c.index_letter == match)){
            class_remove(row,"hidden");
        }else{
	        class_add(row,"hidden");
        }
    }
	dge("cm_search").value="Search contact list...";
	dge("cm_details").innerHTML="";
	class_remove(contacts,'hidden');
}

function cm_update_index()
{
	var type,id;
	var o=new Object;
	var ab=address_book.data;

	var oo=dge("cm_contacts").childNodes;
	for (var i=oo.length-1;i>=0;i--){
		id=oo[i].getAttribute('cm_cid');
		if(!id) continue;
		o[ab[id].index_letter]=true;
	}

	var idx=dge("cm_index").childNodes;
	for (var i=idx.length-1;i>=1;i--){
		type=idx[i].innerHTML;
		if(o[type])
			class_add(idx[i],"cm_present")
		else
			class_remove(idx[i],"cm_present")
	}
	class_add(idx[0],"cm_present");
	cm_index_select(idx[0]);
}


function cm_index_select(el)
{
	if(el.parentNode['sel_idx'])
		class_remove(el.parentNode['sel_idx'],"selected");
	class_add(el,"selected");
	el.parentNode['sel_idx']=el;
}
function contact_error()
{
	alert('There is a problem with your contact information, please contact your support team. Contact related functionality may be broken until this is resolved.');
}

var keep_sorted=false;
var cm_cur_group, cm_cur_client_cid, cm_cur_server_cid, cp_cur_tab, cur_keep_once;

var old_data, old_groups;
function cm_reset_abook(svr_id_reset)
{
	old_data=address_book.data;
	old_groups=address_book.groups;
	address_book.data=[];
	address_book.groups=[];
	cm_cur_client_cid=undefined;
	if(svr_id_reset)
		cm_cur_server_cid=undefined;
}
function cm_restore_abook()
{
	address_book.data=old_data;
	address_book.groups=old_groups;
}

function webmail_import(id)
{
	if (id=='all'){
		if(!confirm("This will do a one way import of all webmail contact information into surgeweb so contact information can be edited within surgeweb.\n\nNote: This will also disable the display of webmail contacts to avoid duplication.")) return;
		dge('cm_abookshow_personal').checked=true;
		dge('cm_abookshow_webmail').checked=false;
		cm_contacts_refresh(true,true);
	}else{	
		webmail_import_one(id);
	}
}
# cf: contact_edit_save
function webmail_import_one(id)
{
	var c,cc,db,fields,email,i;

	fields=[];	
	db=address_book.data;
	c=db[id];
	email=c_email(c).toLowerCase();
	for (i=0;i<db.length;i++){
		cc=db[i];
		if(c_email(cc).toLowerCase().indexOf(email)!=-1 && cc.webmail!=true){
			if(!confirm(email+' already found in surgeweb contacts, are you sure you want to import - this will add another contact with the same email address.'))
				return;
			else
				break;
		}
	}	
	
	fields.push('server_cid=new');
	fields.push('client_cid=');
	fields.push('output=one');
	
	for (k in CFD){
		field=CFD[k];
		if (field.xblank) continue;
		if (!c[k]) continue;
		fields.push('contact_'+k+'='+xescape(serialise(c[k],true,field.plain)));
	}
	fields.push('contact_groups='+xescape('Webmail import'));
	
	var data;
	data='cmd=contact_update,show&page=~contacts.js'+'&'+fields.join('&');
	sndReqPost(data, function(chan){			
		cm_cur_client_cid=address_book.data.length;
		cm_cur_group=1;
		cur_keep_once=true;
		var success=actionReqJsStat(chan);			
		cm_display_init();
	});
}

function contact_copy_one(c,dst_abk)
{
	var c,cc,db,fields,email,i;

	fields=[];	

	fields.push('server_cid=new');
	fields.push('client_cid=');
	fields.push('output=one');
	
	for (k in CFD){
		field=CFD[k];
		if (field.xblank) continue;
		if (!c[k]) continue;
		fields.push('contact_'+k+'='+xescape(serialise(c[k],true,field.plain)));
	}
	fields.push('abook='+dst_abk);
	
	var data;
	data='cmd=contact_update,show&page=~contacts.js'+'&'+fields.join('&');
	sndReqPost(data, function(chan){			
		cm_cur_client_cid=address_book.data.length;
		cm_cur_group=1;
		cur_keep_once=true;
		var success=actionReqJsStat(chan);			
		cm_display_init();
	});
}

function contact_editable(c)
{
	return (!(c.shared || c.webmail) || (c.shared && sw.abooks_write && in_array(c.abook,sw.abooks_write)));
}

function extra_field_im(type,xx,oo)
{
	var out=[], field='network';
	var networks={'msn':'MSN', 'google':'Google Talk', 'aim':'AIM', 'yahoo':'Yahoo', 'icq':'ICQ', 'jabber':'Jabber', 'skype':'Skype', 'dbabble':'DBabble', 'other':'Other'};
	if(type=='edit'){
		out.push('&nbsp;<select '+ctl_xevents[0]+'>');
		for(k in networks)
			out.push('<option value="'+k+'">'+networks[k]+'</option>');
		out.push('</select>');
		return out.join('');
	}else if(type=='show'){
		var v=networks[val(xx,field)];
		if (!v || v.length==0) return '';
		return ' <span style="color:#777">('+v+')</span>';
	}else if(type=='hookup'){
		var el=abook_field2extra(oo);
		el.store=xx;
		el.store_type=field;
	}
	return '';
}



function abook_field2extra(o) {return o.nextSibling.nextSibling};
function abook_field2divdel(o) {return o.parentNode.nextSibling};
function abook_field2outer(o) {return o.parentNode.parentNode};
function abook_outer2prev(o) {return o.previousSibling.previousSibling};
function abook_outer2next(o) {return o.nextSibling};

//cctl_value_init